function RecuperarSenhaController(ScreenService, General, MessageService) {
    
    var self = this;
    var currentStep;
    
    this.onEnter = function(widget){
        toFirstStep(widget);
        widget.newRow();
    };
    
    this.submit = function(widget) {
        if (widget.isValid()) {
            if (currentStep == 1) {
                General.callRestEngine("/sendPwRecoverToken", "Row", widget.currentRow).then(function(){
                    MessageService.showMessageByCode('MSG_SENT_TOKEN');
                    self.toSecondStep(widget);
                }, function(response){
                    var errorMsg = "Erro";
                    errorMsg = response.error || (response.data && response.data.error) || errorMsg;
                    ScreenService.showMessage(ScreenService.i18n(errorMsg), 'E');
                });
            } else if (currentStep == 2) {
                var currentRow = widget.currentRow;
                if (currentRow.newPw == currentRow.confirmPw) {
                    General.callRestEngine("/resetPassword", "Row", widget.currentRow).then(function(){
                        MessageService.showMessageByCode('MSG_SUCCESS_RECOVER');
                        ScreenService.openWindow('product#login');
                    }, function(response){
                        var errorMsg = "Erro";
                        errorMsg = response.error || (response.data && response.data.error) || errorMsg;
                        ScreenService.showMessage(ScreenService.i18n(errorMsg), 'E');
                    });
                } else {
                    MessageService.showMessageByCode('MSG_VALID_PWRECOVER');
                    currentRow.newPw = "";
                    currentRow.confirmPw = "";
                }
            }
            
        }
    };
    
    this.cancel = function(widget){
        ScreenService.openWindow('product#login');
    };
    
    var toFirstStep = function(widget){
        currentStep = 1;
        widget.getField('token').isVisible = false;
        widget.getField('newPw').isVisible = false;
        widget.getField('confirmPw').isVisible = false;
        widget.getField('toSecondStep').isVisible = true;
    };
    
    this.toSecondStep = function(widget){
        currentStep = 2;
        widget.getField('token').isVisible = true;
        widget.getField('newPw').isVisible = true;
        widget.getField('confirmPw').isVisible = true;
        widget.getField('toSecondStep').isVisible = false;
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('RecuperarSenhaController', RecuperarSenhaController);
});