function MyMenuListController($scope, $rootScope, ZHPromise, localStorageEngine, templateManager, $sce) {

	var previousScroll;
	var container = $("#mym-list-container");
	var self = this;
	var defaultListProperties = {
		showImage: false,
		clearChangedOnReload: true
	};
	$scope.listProperties = $scope.widget.listProperties || defaultListProperties;
	$scope.rows = $scope.widget.dataSource.data;
	$scope.widget.itemsPerPage = $scope.widget.itemsPerPage || $scope.widget.dataSource.itemsPerPage;
    $scope.loadedAllData = false;
    $scope.loadingData = false;
	$scope.showLoadMore = true;
	var overlay = document.querySelector(".mym-list-overlay");

	container.nonbounce();

	this.getContainer = function() {
		return templateManager.container;
	};

	this.getListType = function(widget){
		var listType = "default";
		if (widget.listProperties) {
			listType = widget.listProperties.listType || listType;
		}
		return listType;
	};

	$scope.filterTitle = function (item) {
		if (item.isVisible && item.showOnList && item.showAsTitle) {
			return item;
		}
	};

	$scope.filterSubtitle = function (item) {
		if (item.isVisible && item.showOnList && !item.showAsTitle) {
			return item;
		}
	};

	$scope.noMatchVisibility = function() {
		var widget = self.getActiveWidget();
		return Util.isUndefinedOrNull(widget.searchCriteria) || !Object.keys(widget.searchCriteria).length;
	};

	$scope.searchNoMatchVisibility = function() {
		var widget = self.getActiveWidget();
		return !Util.isUndefinedOrNull(widget.searchCriteria) && Object.keys(widget.searchCriteria).length;
	};

	this.onLongTapRow = function (row) {
		var dataArray = $scope.widget.dataSource.data.filter(function(row) {
			return row.dropdownOpened;
		});
		if (!row.__isSelected && $scope.widget.allowSelectOnLongTap && dataArray.length === 0) {
			var widget = self.getActiveWidget();
			for(var i = 0; i< dataArray.length; i++) {
				dataArray[i].dropdownOpened = false;
				document.getElementById('dropdown_' + dataArray[i].$$hashKey).parentElement.classList.remove('list-dropdown-opened');
			}
			$scope.widget.selectAll([row]);
			if (window.navigator.vibrate) {
				window.navigator.vibrate(25);
			}
		}
	};

	this.closeDropdown = function(row) {
		event.preventDefault();
		event.stopPropagation();
		var dataArray = $scope.widget.dataSource.data.filter(function(row) {
			return row.dropdownOpened;
		});
		if(dataArray.length > 0) {
			for(var i = 0; i < dataArray.length; i++) {
				dataArray[i].dropdownOpened = false;
				document.getElementById('dropdown_'+dataArray[i].$$hashKey).parentElement.classList.remove('list-dropdown-opened');
			}
		} else {
			this.setCurrentRow(row);
		}
		overlay.style.display = "none";
	};

	this.setCurrentRow = function (row) {		
		var widget = $scope.widget;		
		if (widget.beforeMoveRow) {		
			event = widget.beforeMoveRow();		
		}		
		if (!event || !event.defaultPrevented) {		
			widget.currentRow = row;		
			if (widget.currentRow && widget.dataSource && widget.dataSource.data) {		
				widget.currentRow.__index = widget.dataSource.data.indexOf(row);		
			}		
			if (templateManager.project.showDescriptionOrder) {		
				widget.computeDescriptionOrder();		
			}		
		}		
		if (!event.cancelBubble) {		
			if (widget.afterMoveRow) {		
				widget.afterMoveRow();		
			}		
		}		
	};

	this.getCheckboxIcon = function(row) {
		if (row.__isSelected) {
			return "checkbox";
		} else {
			return "checkboxoutlineblank";
		}
	};
	this.changeColorField = function(field,widget) {
		var classes;
		var currStatus = field.IDSTATUS;
		var widgetfields = widget.fields;

		widgetfields.forEach(function(fieldOfWidget){
			if(fieldOfWidget.name === "IDSTATUS"){
				classes = fieldOfWidget.classesForTitle;	
			}
		});
		
		if(Util.isUndefinedOrNull(classes)){
			return null;
		}
		if(Util.isUndefinedOrNull(classes[currStatus])){
			return classes.APROVADO;	
		}
		return classes[currStatus];
	};
	this.filteredRows = function() {
		var widget = $scope.widget;
		var searchCriteria = widget.searchCriteria || {};
		var data  = widget.dataSource.data || [];

		function filterComparising(row) {
			var isVisible = false;
			if (Util.objectHasAnyValue(searchCriteria)) {
				Object.keys(searchCriteria).forEach(function(filter) {
					if (!isVisible) {
						if (filter === "_ALL") {
							var fields;
							if (widget.headerSearchBy) {
								widget.headerSearchBy = Array.isArray(widget.headerSearchBy) ? widget.headerSearchBy : [widget.headerSearchBy];
								fields = widget.headerSearchBy;
							} else {
								fields = getVisibleFields();
							}
							fields.forEach(function(field) {
								if (!isVisible) {
									isVisible = compareValues(row[field], searchCriteria[filter], isVisible);
								}
							});
						} else {
							isVisible = compareValues(row[filter], searchCriteria[filter], isVisible);
						}
					}
				});
			} else {
				isVisible = true;
			}
			return isVisible;
		}

		function getVisibleFields() {
			return widget.fields.map(function(field) {
				if (field.isVisible && field.showOnList) {
					return field.name;
				}
			});
		}

		function compareValues(rowValue, filterValue) {
			if (!Util.isUndefinedOrNull(rowValue)) {
				rowValue = rowValue.toLowerCase();
				rowValue = rowValue.latinize();
				filterValue = filterValue.toLowerCase();
				filterValue = filterValue.latinize();
				if (rowValue.search(filterValue) !== -1) {
					return true;
				}
			}
			return false;
		}
		return data.filter(filterComparising);
	};

	this.toggleImageCheckbox = function(row) {
		var widget = self.getActiveWidget();
		if (widget.listProperties.showCheckbox) {
			this.toggle(row);
		}
	};


	this.openDetail = function (row, widget) {
		row.__showDetail = true;
		widget.detailRow = row;
		widget.isShowingDetail = true;
		if (widget.detailWidget) {
			var widgetToActivate = widget.container.getWidget(widget.detailWidget);
			widgetToActivate.listDetailWidget = widget;
			widgetToActivate.activate();
		}
	};

	this.closeDetail = function (widget) {
		var row = widget.detailRow;
		row.__showDetail = false;
		delete widget.detailRow;
		widget.isShowingDetail = false;
		if (widget.listDetailWidget) {
			var widgetToActivate = widget.listDetailWidget;
			widgetToActivate.activate();
		}
	};
	

	this.getActiveWidget = function() {
		return self.getContainer().getActiveWidget();
	};

	this.getClosedStatus = function(row) {
		var status = false;
		if (row && row.__groupHeaders && row.__groupHeaders.length > 0) {
			status = row.__groupHeaders.some(function(group) {
				return group.__groupOpened === false;
			});
		}
		return status;
	};

	this.toggle = function(row) {
		var widget = $scope.widget;
		widget.selectedRow = row;

		var event;
		if (widget.beforeSelectRow && !row.__isSelected) {
			event = widget.beforeSelectRow();
		} else if (widget.beforeUnselectRow && row.__isSelected) {
			event = widget.beforeUnselectRow();
		}
		if (!event || !event.isDefaultPrevented()) {
			var index = getIndex(row);
			if (index === -1) {
				row.__isSelected = true;
				if (!$scope._currentPopup) $rootScope.$broadcast("ui.addToFooter", "showOnMultiSelect");
			} else {
				delete row.__isSelected;
				widget.dataSource.removeCheckedRows(row);
			}
			if (!$scope._currentPopup && !widget.dataSource.checkedRows.length) {
				$rootScope.$broadcast("ui.removeFromFooter", "showOnMultiSelect");
			}

			widget.updateCheckedRows();

			if (widget.afterSelectRow && row.__isSelected) {
				widget.afterSelectRow();
			} else if (widget.afterUnselectRow && !row.__isSelected) {
				widget.afterUnselectRow();
			}
		}
	};

	function getIndex(row) {
		return $scope.widget.dataSource.checkedRows.indexOf(row);
	}

	this.toggleDropdown = function(row, e) {
		if (!$scope.widget.hasCheckedRows()) {
			var dataArray = $scope.widget.dataSource.data.filter(function(row) {
				return row.dropdownOpened === true;
			});

			if(dataArray.length < 1) {
				var htmlElementTarget = e.target;
				var dropdownContent = htmlElementTarget.parentElement.parentElement.parentElement.lastElementChild.firstElementChild;
				var dropdown = htmlElementTarget.parentElement.parentElement.parentElement.lastElementChild;
				var availSpace = screen.availHeight - dropdownContent.getBoundingClientRect().top - (screen.availHeight/15);
				if (availSpace > dropdownContent.offsetHeight) {
					dropdownContent.classList.remove('list-dropdown-last');
				} else {
					dropdownContent.classList.add('list-dropdown-last');
				}
				if(!($scope.widget.hasCheckedRows())) {
					row.dropdownOpened = !row.dropdownOpened;
					if(row.dropdownOpened) {
						dropdown.classList.add('list-dropdown-opened');
					} else {
						dropdown.classList.remove('list-dropdown-opened');
					}
				}
				overlay.style.display = "block";
			} else {
				for(var i=0; i<$scope.widget.dataSource.data.length; i++) {
					$scope.widget.dataSource.data[i].dropdownOpened=false;
					document.getElementById('dropdown_'+i).parentElement.classList.remove('list-dropdown-opened');
				}
			}
			e.preventDefault();
			e.stopPropagation();
		} else {
			e.stopPropagation();
			self.toggle(row);
		}
	};

	this.onActionClick = function(action, actionClick, row) {
		if(!($scope.widget.hasCheckedRows())) {
			var activeWidget = self.getActiveWidget();
			event.stopPropagation();
			event.preventDefault();
			actionClick(action, activeWidget, row);
		} else {
			self.toggle(row);
		}
		self.closeDropdown(row);
	};

   	/**
     * Provide endless scroll on list container
     */
    this.infiniteScroll = function() {
        var scrollHeight = container[0].scrollHeight;
        var scrollPosition = container.height() + container.scrollTop();
        previousScroll = previousScroll || scrollPosition;
        if (((scrollHeight - scrollPosition) / scrollHeight < 0.030) && previousScroll < scrollPosition && !$scope.loadingData && !$scope.loadedAllData) {
            this.loadData(true);
        }
        previousScroll = scrollPosition;
    };

    /**
     * Retrieve content from list dataSource
     * @param  {Boolean} apply - Scope apply selector
     */
    this.loadData = function(apply) {
        $scope.loadingData = true;
    	$('.default-window>.zh-background-loading').addClass("list-hide-loader-overlay");
    	$('.zh-background-loading>.zh-position-loading>.zh-loading-icon').css("display", "none");
        if (apply) {
            $scope.$apply();
        }
        var widget = $scope.widget;
        this.nextPage(widget).then(function(callback) {
        	var data;
            if (callback && callback.dataset) {
                Object.keys(callback.dataset).forEach(function (datasetName) {
                    data = callback.dataset[datasetName];
                });
            } else {
                data = callback || [];
            }
            $scope.loadedAllData = data.length < widget.itemsPerPage;
            this.loadMoreVisibility();
            $scope.loadingData = false;
            $('.default-window>.zh-background-loading').removeClass("list-hide-loader-overlay");
	        $('.zh-background-loading>.zh-position-loading>.zh-loading-icon').css("display", "inline-block");
        }.bind(this));
    };

    /**
     * Manage load more button visibility
     */
    this.loadMoreVisibility = function() {
    	var listContainer = $('#mym-list-container')[0];
    	if (listContainer) {
	        var scrollHeight = listContainer.scrollHeight + $('.lf-navbar').height();
	        var windowHeight = $(window).height();
	        if (scrollHeight > windowHeight) {
	            $scope.showLoadMore = false;
	        } else {
	            $scope.showLoadMore = true;
	        }

    	}
    };

    /**
     * Retrieve next page of widget's datasource
     * @param  {Widget} widget
     * @return {ZHPromise} Load function callback
     */
    this.nextPage = function(widget) {
        if (widget.dataSource) {
            return widget.dataSource.load(widget.getDataSourceFilter(), widget.dataSource.getNextPage(), widget.itemsPerPage);
        } else {
            return ZHPromise.when();
        }
    };

    this.getRowImage = function(row) {
    	var title = "";
    	if ($scope.listProperties.imageTitleField && row[$scope.listProperties.imageTitleField]) {
    		title = row[$scope.listProperties.imageTitleField].toString().substr(0,1);
    	}
    	return title;
    };

    this.isActionVisible = function(row, action) {
    	var isVisible = action.condition ? eval(action.condition) : action.isVisible; // jshint ignore:line
    	return isVisible;
	};
	
	this.trustAsHtml = function(htmlContent) {
		return $sce.trustAsHtml(htmlContent);
	};

    $scope.filterRowActions = function(action) {
    	if (action.showAsAction.indexOf("|") === -1) {
    		return action.showAsAction === "row";
    	} else {
    		var showAsAction = action.showAsAction.split("|");
    		var isVisible = false;
    		for (var i = 0; i < showAsAction.length; i++) {
    			if (showAsAction[i] === "row") {
    				isVisible = true;
    				break;
    			}
    		}
    		return isVisible;
    	}
    };
	/**
	 * Overwrite default reload action of widget
	 * @param {Object[]} additionalFilters - (Optional) Filters to be applied on reload
	 * @param {Boolean} shouldRefreshCurrentRow - (Optional) True if should refresh current row
	 */
	if (!$scope.widget.defaultReload) {
		$scope.widget.defaultReload = angular.copy($scope.widget.reload);
	    $scope.widget.reload = function(additionalFilters, shouldRefreshCurrentRow) {
	    	$scope.loadingData = true;
	    	$('.default-window>.zh-background-loading').addClass("list-hide-loader-overlay");
    		$('.zh-background-loading>.zh-position-loading>.zh-loading-icon').css("display", "none");
	        if ($scope.listProperties.clearChangedOnReload) {
	        	$scope.widget.dataSource.clearChangedRows();
	        }
	        return $scope.widget.defaultReload(additionalFilters, shouldRefreshCurrentRow).then(function() {
	            container.scrollTop(0);
	            $scope.loadedAllData = false;
	            $scope.loadingData = false;
	            $('.default-window>.zh-background-loading').removeClass("list-hide-loader-overlay");
	        	$('.zh-background-loading>.zh-position-loading>.zh-loading-icon').css("display", "inline-block");
	            $scope.widget.dataSource.updateChangedRows();
	        }.bind(this));
	    };
	}

	if (!$scope.widget.dataSource.updateChangedRows) {
		var dataSource = $scope.widget.dataSource;
		var ignoreKeys = ['__rightActions', '__leftActions'];

		dataSource._changedRows = [];
		dataSource._changedRowsCache = {};

		dataSource.getHashKey = function(row) {
			var VO = this.getVO();
			var hash = "";
			if (VO && VO.localKey) {
				hash = VO.localKey.reduce(function(hash, key) {
					return row[key] ? hash + "_" + row[key].toString() : hash;
				}, "");
			}
			return hash;
		};

		dataSource.addChangedRows = function (rows) {
			rows = Util.parseToArray(rows);
			rows.forEach(function(row) {
				if (this._changedRows.indexOf(row) === -1) {
					this._changedRows.push(row);
				}
				var hash = this.getHashKey(row);
				if (hash) {
					this._changedRowsCache[hash] = Util.clone(row, ignoreKeys);
				}
			}.bind(this));
		};

		dataSource.clearChangedRows = function() {
			this._changedRows = [];
			this._changedRowsCache = {};
		};

		dataSource.getChangedRows = function() {
			var changedRows = this._changedRows;
			if (this.name) {
				var changedRowsHash = changedRows.map(function(row) {
					return this.getHashKey(row);
				}.bind(this));
				changedRows = changedRows.concat(Object.keys(this._changedRowsCache).filter(function(row) {
					return changedRowsHash.indexOf(row) === -1;
				}.bind(this)).map(function(hash) {
					return this._changedRowsCache[hash];
				}.bind(this)));
			}
			return changedRows;
		};

		dataSource.updateChangedRows = function() {
			if (this.data) {
				this._changedRows = this.data.filter(function(row) {
					var hash = this.getHashKey(row);
					if (this._changedRowsCache.hasOwnProperty(hash)) {
						for (var i in this._changedRowsCache[hash]) {
							row[i] = this._changedRowsCache[hash][i];
						}
					}
					return row.changed;
				}.bind(this));
			} else {
				this.clearChangedRows();
			}
			if (templateManager.container) {
				templateManager.container.updateCheckedRows();
			}
		};
	}

	if (!$scope.widget.cancel) {
		$scope.widget.cancel = this.cancel;
	}

    container.on("scroll", this.infiniteScroll.bind(this));
    $(window).on("resize", this.loadMoreVisibility);
}